# -*- coding: utf-8 -*-
# Part of Odoo. See LICENSE file for full copyright and licensing details.

from odoo import api, models, fields, tools, _
from odoo.tools import DEFAULT_SERVER_DATE_FORMAT, float_repr
from odoo.tests.common import Form
from odoo.exceptions import UserError

from datetime import datetime, date
from lxml import etree
from PyPDF2 import PdfFileReader
import base64
import logging

import requests
import json

_logger = logging.getLogger(__name__)

class BlogPost(models.Model):
    _inherit = 'blog.post'

    blog_url = fields.Char('Teaser', compute='_compute_blog_url',store=True,index=True)
    piblished_on_fb = fields.Boolean('Published on Facebook', default=False,index=True)

    @api.depends('name', 'blog_id.name')
    def _compute_blog_url(self):
        for rec in self:
            base_url = self.env['ir.config_parameter'].sudo().get_param('web.base.url')
            blog_url = ''
            self._cr.execute("""select 
replace(concat('/blog/', lower(REPLACE(bb.name,' ', '-')) , '-' , bb.id , '/post/' , lower(REPLACE(translate(lower( bp.name ), ' ''àáâãäéèëêíìïîóòõöôúùüûçÇ', '--aaaaaeeeeiiiiooooouuuucc'),' ', '-')) , '-' , bp.id ),'"','') as post_url
from blog_post bp 
left join blog_blog bb on (bb.id = bp.blog_id) where bp.id=%s"""%(rec.id))
            result = self._cr.fetchall()
            for res in result:
                blog_url = base_url + res[0]
            rec.blog_url = blog_url

    def publish_to_facebook(self):
        msg = self.name
        link = self.blog_url
        #msg = 'Teste JCF'
        facebook_page_id = self.env.user.company_id.facebook_page_id
        facebook_page_access_token = self.env.user.company_id.facebook_page_access_token
        facebook_url = self.env.user.company_id.facebook_url
        
        post_url = facebook_url.format(facebook_page_id)

        payload = {
            'message':msg,
            'link':link,
            'access_token':facebook_page_access_token
        }
        _logger.info("POST URL ::::::::::::::::::::::::::::::::::: %s",post_url)

        _logger.info("PAYLOAD ::::::::::::::::::::::: %s ",payload)

        r = requests.post(post_url,data=payload)
        content = json.loads(r.text)
        
        _logger.info("CONTENT ::::::::::::::::::::::: %s ",content)
        try:
            response_id = content.get('id')
            _logger.info("RESPONSE ID ::::::::::::::::::::::: %s ",response_id)
            response_split = response_id.split("_")
            _logger.info("RESPONSE SPLIT 0 ::::::::::::::::::::::: %s ",response_split[0])
            _logger.info("PAGE ID ::::::::::::::::::::::: %s ",facebook_page_id)
            if response_split[0] == facebook_page_id:
                self.write({'piblished_on_fb':True})

        except Exception:
            pass
        
        
    def write(self, vals):
        _logger.info("VALS WRITE BLOG %s ::::::::::::::::::::::: ",vals)
        context = self._context
        _logger.info("CONTEXT %s ::::::::::::::::::::::: ",context)
        res = super(BlogPost, self).write(vals)
        
        if 'piblished_on_fb' in vals:
            piblished_on_fb = vals['piblished_on_fb']
        else:
            piblished_on_fb = self.piblished_on_fb
        
        if not piblished_on_fb:
            if 'is_published' in vals:
                if vals['is_published']:
                    self.publish_to_facebook()
        return res
